input_file = snakemake.input[0]
output_file = snakemake.output[0]
gridsize = snakemake.params.gridsize

import numpy as np

def NumberOfNeighbors(i,j,grid):
    NN = 0
    for I in range(i-1,i+2,1):
        if(I < 0 or I > gridsize-1): continue
        for J in range(j-1,j+2,1):
            if(J < 0 or J > gridsize-1): continue
            if(I == i and J == j): continue
            NN += grid[I][J]
    return NN
            
def Rules(i,j,grid):
    NN = NumberOfNeighbors(i,j,grid)
    if(NN == 3): return 1 # lives happily or is born
    elif(NN == 2 and grid[i][j] == 1): return 1
    else: return 0

#get grid from last time stamp
with open(input_file,"rb") as input:
    grid_old = np.load(input)

#compute grid for new time stamp
grid_new = np.copy(grid_old) #copy very important, otherwise pointerlike!
for i in range(gridsize):
    for j in range(gridsize):
        grid_new[i][j] = Rules(i,j,grid_old)
    
#same new grid to file
with open(output_file,"wb") as output:
    np.save(output, np.array(grid_new))
